searchData={"items":[{"type":"module","title":"IbkrApi.AssetClass","doc":"Asset class module for IBKR Client Portal API.","ref":"IbkrApi.AssetClass.html"},{"type":"function","title":"IbkrApi.AssetClass.bond/0","doc":"","ref":"IbkrApi.AssetClass.html#bond/0"},{"type":"function","title":"IbkrApi.AssetClass.contract_for_difference/0","doc":"","ref":"IbkrApi.AssetClass.html#contract_for_difference/0"},{"type":"function","title":"IbkrApi.AssetClass.forex/0","doc":"","ref":"IbkrApi.AssetClass.html#forex/0"},{"type":"function","title":"IbkrApi.AssetClass.future/0","doc":"","ref":"IbkrApi.AssetClass.html#future/0"},{"type":"function","title":"IbkrApi.AssetClass.inter_commodity_spread/0","doc":"","ref":"IbkrApi.AssetClass.html#inter_commodity_spread/0"},{"type":"function","title":"IbkrApi.AssetClass.mutual_fund/0","doc":"","ref":"IbkrApi.AssetClass.html#mutual_fund/0"},{"type":"function","title":"IbkrApi.AssetClass.option/0","doc":"","ref":"IbkrApi.AssetClass.html#option/0"},{"type":"function","title":"IbkrApi.AssetClass.stock/0","doc":"","ref":"IbkrApi.AssetClass.html#stock/0"},{"type":"function","title":"IbkrApi.AssetClass.warrent/0","doc":"","ref":"IbkrApi.AssetClass.html#warrent/0"},{"type":"module","title":"IbkrApi.Backtester.Bar","doc":"Historical market data bar structure for backtesting.\n\nThis module provides a standardized bar structure and conversion utilities\nfor backtesting with IBKR historical data.","ref":"IbkrApi.Backtester.Bar.html"},{"type":"function","title":"IbkrApi.Backtester.Bar.bearish?/1","doc":"Returns true if the bar is bearish (close < open).","ref":"IbkrApi.Backtester.Bar.html#bearish?/1"},{"type":"function","title":"IbkrApi.Backtester.Bar.bullish?/1","doc":"Returns true if the bar is bullish (close > open).","ref":"IbkrApi.Backtester.Bar.html#bullish?/1"},{"type":"function","title":"IbkrApi.Backtester.Bar.from_historical_bar/1","doc":"Converts IbkrApi.ClientPortal.MarketData.HistoricalBar to IbkrApi.Backtester.Bar.\n\nThis provides compatibility between the IBKR API module and backtesting framework.","ref":"IbkrApi.Backtester.Bar.html#from_historical_bar/1"},{"type":"function","title":"IbkrApi.Backtester.Bar.from_ibkr/1","doc":"Converts IBKR API response data to IbkrApi.Backtester.Bar struct.","ref":"IbkrApi.Backtester.Bar.html#from_ibkr/1"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Bar.from_ibkr/1","doc":"- `data`: Map containing IBKR bar data with keys \"t\", \"o\", \"h\", \"l\", \"c\", \"v\"","ref":"IbkrApi.Backtester.Bar.html#from_ibkr/1-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Bar.from_ibkr/1","doc":"iex> IbkrApi.Backtester.Bar.from_ibkr(%{\"t\" => 1707139200000, \"o\" => 189.9, \"h\" => 190.3, \"l\" => 188.7, \"c\" => 189.5, \"v\" => 24018321})\n    %IbkrApi.Backtester.Bar{\n      timestamp: ~U[2024-02-05 13:20:00.000Z],\n      open: 189.9,\n      high: 190.3,\n      low: 188.7,\n      close: 189.5,\n      volume: 24018321\n    }","ref":"IbkrApi.Backtester.Bar.html#from_ibkr/1-examples"},{"type":"function","title":"IbkrApi.Backtester.Bar.range/1","doc":"Returns the price range (high - low) for the bar.","ref":"IbkrApi.Backtester.Bar.html#range/1"},{"type":"type","title":"IbkrApi.Backtester.Bar.t/0","doc":"","ref":"IbkrApi.Backtester.Bar.html#t:t/0"},{"type":"function","title":"IbkrApi.Backtester.Bar.typical_price/1","doc":"Returns the typical price (HLC/3) for the bar.","ref":"IbkrApi.Backtester.Bar.html#typical_price/1"},{"type":"module","title":"IbkrApi.Backtester.Engine","doc":"Backtesting engine that runs strategies against historical data.\n\nThe engine processes historical bars sequentially, calling the strategy\nfor each bar and executing the resulting trades on the portfolio.","ref":"IbkrApi.Backtester.Engine.html"},{"type":"function","title":"IbkrApi.Backtester.Engine.calculate_metrics/1","doc":"Calculates key performance metrics for a backtest result.","ref":"IbkrApi.Backtester.Engine.html#calculate_metrics/1"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Engine.calculate_metrics/1","doc":"- `result`: Result map from run/3 or run_detailed/3","ref":"IbkrApi.Backtester.Engine.html#calculate_metrics/1-parameters"},{"type":"function","title":"Returns - IbkrApi.Backtester.Engine.calculate_metrics/1","doc":"Extended performance metrics including:\n- Sharpe ratio (if portfolio_values available)\n- Maximum drawdown\n- Win rate\n- Average trade return","ref":"IbkrApi.Backtester.Engine.html#calculate_metrics/1-returns"},{"type":"function","title":"IbkrApi.Backtester.Engine.run/3","doc":"Runs a backtest with the given bars and strategy.","ref":"IbkrApi.Backtester.Engine.html#run/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Engine.run/3","doc":"- `bars`: List of historical bars (chronologically ordered, oldest first)\n- `strategy_module`: Module implementing the IbkrApi.Backtester.Strategy behaviour\n- `opts`: Optional configuration\n  - `:starting_cash` - Initial portfolio cash (default: 100,000.0)\n  - `:strategy_opts` - Options passed to strategy.init/1 (default: [])","ref":"IbkrApi.Backtester.Engine.html#run/3-parameters"},{"type":"function","title":"Returns - IbkrApi.Backtester.Engine.run/3","doc":"A map containing:\n- `:portfolio` - Final portfolio state\n- `:performance` - Performance statistics\n- `:trade_history` - List of all executed trades\n- `:bars_processed` - Number of bars processed","ref":"IbkrApi.Backtester.Engine.html#run/3-returns"},{"type":"function","title":"Examples - IbkrApi.Backtester.Engine.run/3","doc":"iex> bars = [%IbkrApi.Backtester.Bar{close: 100.0, open: 99.0, high: 101.0, low: 98.0, volume: 1000, timestamp: DateTime.utc_now()}]\n    iex> result = IbkrApi.Backtester.Engine.run(bars, IbkrApi.Backtester.Strategies.MA)\n    iex> is_map(result)\n    true","ref":"IbkrApi.Backtester.Engine.html#run/3-examples"},{"type":"function","title":"IbkrApi.Backtester.Engine.run_detailed/3","doc":"Runs a backtest and returns detailed results with bar-by-bar portfolio values.\n\nThis version tracks portfolio value at each bar for plotting and analysis.","ref":"IbkrApi.Backtester.Engine.html#run_detailed/3"},{"type":"module","title":"IbkrApi.Backtester.Example","doc":"Example usage of the IBKR backtesting framework.\n\nThis module demonstrates how to fetch historical data from IBKR\nand run backtests with different strategies.","ref":"IbkrApi.Backtester.Example.html"},{"type":"function","title":"IbkrApi.Backtester.Example.compare_strategies/5","doc":"Demonstrates multiple strategy comparison.\n\nRuns the same historical data through different strategies and compares results.","ref":"IbkrApi.Backtester.Example.html#compare_strategies/5"},{"type":"function","title":"IbkrApi.Backtester.Example.print_report/1","doc":"Print a formatted backtest report.","ref":"IbkrApi.Backtester.Example.html#print_report/1"},{"type":"function","title":"IbkrApi.Backtester.Example.run_backtest/5","doc":"Complete example: Search for a contract, fetch historical data, and run backtest.","ref":"IbkrApi.Backtester.Example.html#run_backtest/5"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Example.run_backtest/5","doc":"- `symbol`: Stock symbol to backtest (e.g., \"AAPL\")\n- `period`: Historical data period (e.g., \"1mo\", \"3mo\", \"1y\")\n- `bar_size`: Bar size (e.g., \"1day\", \"1hour\", \"30min\")\n- `strategy_module`: Strategy module to use (default: MA strategy)\n- `opts`: Additional options","ref":"IbkrApi.Backtester.Example.html#run_backtest/5-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Example.run_backtest/5","doc":"# Run a simple moving average backtest on Apple stock\n    iex> IbkrApi.Backtester.Example.run_backtest(\"AAPL\", \"3mo\", \"1day\")\n    {:ok, %{performance: %{return_percent: 12.5, ...}, ...}}\n\n    # Run with custom strategy options\n    iex> IbkrApi.Backtester.Example.run_backtest(\"MSFT\", \"6mo\", \"1hour\",\n    ...>   IbkrApi.Backtester.Strategies.MA, strategy_opts: [window: 20])\n    {:ok, %{...}}","ref":"IbkrApi.Backtester.Example.html#run_backtest/5-examples"},{"type":"function","title":"IbkrApi.Backtester.Example.run_sample_backtest/1","doc":"Quick backtest example with sample data (for testing without API calls).\n\nGenerates synthetic price data and runs a backtest.","ref":"IbkrApi.Backtester.Example.html#run_sample_backtest/1"},{"type":"module","title":"IbkrApi.Backtester.Portfolio","doc":"Portfolio management for backtesting.\n\nTracks cash, positions, and trade history during backtesting simulations.\nSupports simple long-only strategies with buy/sell/hold operations.","ref":"IbkrApi.Backtester.Portfolio.html"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.buy/3","doc":"Executes a buy order if no position is currently held.","ref":"IbkrApi.Backtester.Portfolio.html#buy/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.buy/3","doc":"- `portfolio`: Current portfolio state\n- `price`: Price per share to buy at\n- `timestamp`: Optional timestamp for the trade (defaults to current time)","ref":"IbkrApi.Backtester.Portfolio.html#buy/3-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.buy/3","doc":"iex> portfolio = %IbkrApi.Backtester.Portfolio{cash: 10000.0, position: 0}\n    iex> result = IbkrApi.Backtester.Portfolio.buy(portfolio, 150.0)\n    iex> result.cash\n    9850.0\n    iex> result.position\n    1\n    iex> result.entry_price\n    150.0","ref":"IbkrApi.Backtester.Portfolio.html#buy/3-examples"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.hold/1","doc":"Returns the portfolio unchanged (hold position).","ref":"IbkrApi.Backtester.Portfolio.html#hold/1"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.new/1","doc":"Creates a new portfolio with the specified starting cash.","ref":"IbkrApi.Backtester.Portfolio.html#new/1"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.new/1","doc":"iex> IbkrApi.Backtester.Portfolio.new(50_000.0)\n    %IbkrApi.Backtester.Portfolio{cash: 50000.0, position: 0, entry_price: nil, trades: []}","ref":"IbkrApi.Backtester.Portfolio.html#new/1-examples"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.performance_stats/3","doc":"Returns portfolio performance statistics.","ref":"IbkrApi.Backtester.Portfolio.html#performance_stats/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.performance_stats/3","doc":"- `portfolio`: Current portfolio state\n- `current_price`: Current market price (for unrealized P&L calculation)\n- `starting_value`: Initial portfolio value (defaults to 100,000.0)","ref":"IbkrApi.Backtester.Portfolio.html#performance_stats/3-parameters"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.realized_pnl/1","doc":"Calculates the realized P&L from completed trades.\n\nOnly considers buy/sell pairs, ignoring any open position.","ref":"IbkrApi.Backtester.Portfolio.html#realized_pnl/1"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.sell/3","doc":"Sell shares at the given price if a position is currently held.","ref":"IbkrApi.Backtester.Portfolio.html#sell/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.sell/3","doc":"- `portfolio`: Current portfolio state\n- `price`: Price per share to sell at\n- `timestamp`: Optional timestamp for the trade (defaults to current time)","ref":"IbkrApi.Backtester.Portfolio.html#sell/3-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.sell/3","doc":"iex> portfolio = %IbkrApi.Backtester.Portfolio{cash: 8500.0, position: 1, entry_price: 150.0}\n    iex> result = IbkrApi.Backtester.Portfolio.sell(portfolio, 160.0)\n    iex> result.cash\n    8660.0\n    iex> result.position\n    0\n    iex> result.entry_price\n    nil","ref":"IbkrApi.Backtester.Portfolio.html#sell/3-examples"},{"type":"type","title":"IbkrApi.Backtester.Portfolio.t/0","doc":"","ref":"IbkrApi.Backtester.Portfolio.html#t:t/0"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.total_value/2","doc":"Calculates the current total value of the portfolio.","ref":"IbkrApi.Backtester.Portfolio.html#total_value/2"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.total_value/2","doc":"- `portfolio`: Current portfolio state\n- `current_price`: Current market price of the held security (if any)","ref":"IbkrApi.Backtester.Portfolio.html#total_value/2-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.total_value/2","doc":"iex> portfolio = %IbkrApi.Backtester.Portfolio{cash: 8500.0, position: 1, entry_price: 150.0}\n    iex> IbkrApi.Backtester.Portfolio.total_value(portfolio, 160.0)\n    8660.0","ref":"IbkrApi.Backtester.Portfolio.html#total_value/2-examples"},{"type":"type","title":"IbkrApi.Backtester.Portfolio.trade/0","doc":"","ref":"IbkrApi.Backtester.Portfolio.html#t:trade/0"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.unrealized_pnl/2","doc":"Calculates the unrealized P&L for the current position.\n\nReturns 0.0 if no position is held.","ref":"IbkrApi.Backtester.Portfolio.html#unrealized_pnl/2"},{"type":"module","title":"IbkrApi.Backtester.Strategies.MA","doc":"Simple Moving Average crossover strategy.\n\nGenerates buy signals when price is above the moving average\nand sell signals when price is below the moving average.","ref":"IbkrApi.Backtester.Strategies.MA.html"},{"type":"function","title":"IbkrApi.Backtester.Strategies.MA.calculate_sma/2","doc":"Calculates Simple Moving Average for the given bars.","ref":"IbkrApi.Backtester.Strategies.MA.html#calculate_sma/2"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Strategies.MA.calculate_sma/2","doc":"- `bars`: List of bars (most recent first)\n- `window`: Number of periods to average","ref":"IbkrApi.Backtester.Strategies.MA.html#calculate_sma/2-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Strategies.MA.calculate_sma/2","doc":"iex> bars = [%{close: 100}, %{close: 102}, %{close: 98}]\n    iex> IbkrApi.Backtester.Strategies.MA.calculate_sma(bars, 3)\n    100.0","ref":"IbkrApi.Backtester.Strategies.MA.html#calculate_sma/2-examples"},{"type":"function","title":"IbkrApi.Backtester.Strategies.MA.init/1","doc":"Initialize the strategy with configuration options.","ref":"IbkrApi.Backtester.Strategies.MA.html#init/1"},{"type":"function","title":"Options - IbkrApi.Backtester.Strategies.MA.init/1","doc":"- `:window` - Moving average window size (default: 5)","ref":"IbkrApi.Backtester.Strategies.MA.html#init/1-options"},{"type":"function","title":"Examples - IbkrApi.Backtester.Strategies.MA.init/1","doc":"iex> IbkrApi.Backtester.Strategies.MA.init(window: 10)\n    %{window: 10}","ref":"IbkrApi.Backtester.Strategies.MA.html#init/1-examples"},{"type":"function","title":"IbkrApi.Backtester.Strategies.MA.signal/3","doc":"Generates trading signals based on moving average crossover.","ref":"IbkrApi.Backtester.Strategies.MA.html#signal/3"},{"type":"function","title":"Logic - IbkrApi.Backtester.Strategies.MA.signal/3","doc":"- Buy when current price > moving average\n- Sell when current price < moving average  \n- Hold when price equals moving average or insufficient data","ref":"IbkrApi.Backtester.Strategies.MA.html#signal/3-logic"},{"type":"behaviour","title":"IbkrApi.Backtester.Strategy","doc":"Behaviour for defining backtesting strategies.\n\nStrategies implement the `signal/3` callback to generate buy/sell/hold signals\nbased on current market data and historical context.","ref":"IbkrApi.Backtester.Strategy.html"},{"type":"callback","title":"IbkrApi.Backtester.Strategy.init/1","doc":"Optional callback for strategy initialization.\n\nCalled once before backtesting begins. Can be used to set up\ninitial state, validate parameters, etc.\n\nDefault implementation returns an empty map.","ref":"IbkrApi.Backtester.Strategy.html#c:init/1"},{"type":"callback","title":"IbkrApi.Backtester.Strategy.signal/3","doc":"Generates a trading signal based on current bar and historical data.","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3"},{"type":"callback","title":"Parameters - IbkrApi.Backtester.Strategy.signal/3","doc":"- `current_bar`: The current bar being processed\n- `previous_bars`: List of previous bars (most recent first)\n- `state`: Strategy-specific state map for maintaining indicators, etc.","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3-parameters"},{"type":"callback","title":"Returns - IbkrApi.Backtester.Strategy.signal/3","doc":"A tuple containing the signal (`:buy`, `:sell`, or `:hold`) and updated state.","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3-returns"},{"type":"callback","title":"Examples - IbkrApi.Backtester.Strategy.signal/3","doc":"def signal(bar, prev_bars, state) do\n      if bar.close > calculate_sma(prev_bars, 20) do\n        {:buy, state}\n      else\n        {:sell, state}\n      end\n    end","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3-examples"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.EndSessionResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.EndSessionResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.IServer","doc":"","ref":"IbkrApi.ClientPortal.Auth.IServer.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.PingServerResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.PingServerResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.ReauthenticateResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.ReauthenticateResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.ServerInfo","doc":"","ref":"IbkrApi.ClientPortal.Auth.ServerInfo.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.ValidateSSOResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.ValidateSSOResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Contract","doc":"Contract information within stock security definition","ref":"IbkrApi.ClientPortal.Contract.Contract.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractDetails","doc":"","ref":"IbkrApi.ClientPortal.Contract.ContractDetails.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractId","doc":"Contract ID information","ref":"IbkrApi.ClientPortal.Contract.ContractId.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractIssuer","doc":"Bond issuer information","ref":"IbkrApi.ClientPortal.Contract.ContractIssuer.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractSection","doc":"Contract section information within search results","ref":"IbkrApi.ClientPortal.Contract.ContractSection.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.CurrencyPair","doc":"Available currency pair information","ref":"IbkrApi.ClientPortal.Contract.CurrencyPair.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Schedule","doc":"Daily trading schedule information","ref":"IbkrApi.ClientPortal.Contract.Schedule.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SearchContract","doc":"Contract search result","ref":"IbkrApi.ClientPortal.Contract.SearchContract.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Secdef","doc":"Security definition structure","ref":"IbkrApi.ClientPortal.Contract.Secdef.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SecdefInfo","doc":"Detailed contract information from secdef/info endpoint","ref":"IbkrApi.ClientPortal.Contract.SecdefInfo.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SecurityFutures","doc":"","ref":"IbkrApi.ClientPortal.Contract.SecurityFutures.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SecurityStocks","doc":"","ref":"IbkrApi.ClientPortal.Contract.SecurityStocks.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Session","doc":"Trading session information","ref":"IbkrApi.ClientPortal.Contract.Session.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.StockSecurityDefinition","doc":"Stock security definition response","ref":"IbkrApi.ClientPortal.Contract.StockSecurityDefinition.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.StrikesResponse","doc":"Response structure for option strikes","ref":"IbkrApi.ClientPortal.Contract.StrikesResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.TradingSchedule","doc":"Complete trading schedule for an exchange","ref":"IbkrApi.ClientPortal.Contract.TradingSchedule.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.TradingTime","doc":"Trading time information within a trading schedule","ref":"IbkrApi.ClientPortal.Contract.TradingTime.html"},{"type":"module","title":"IbkrApi.ClientPortal.MarketData","doc":"Market Data functionality for the IBKR Client Portal API.\n\nThis module provides functions to retrieve live market data snapshots and other\nmarket data related information.","ref":"IbkrApi.ClientPortal.MarketData.html"},{"type":"function","title":"IbkrApi.ClientPortal.MarketData.get_historical_data/4","doc":"Retrieves historical market data for a contract.","ref":"IbkrApi.ClientPortal.MarketData.html#get_historical_data/4"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.MarketData.get_historical_data/4","doc":"- `conid`: Contract identifier\n- `period`: Duration of data to fetch (e.g., \"1w\", \"1mo\", \"1d\", \"2h\")\n- `bar`: Bar size (e.g., \"1hour\", \"5min\", \"1day\")\n- `opts`: Optional parameters\n  - `:outside_rth` - Include extended hours? (default: false)\n  - `:exchange` - Optional exchange (default: \"SMART\")","ref":"IbkrApi.ClientPortal.MarketData.html#get_historical_data/4-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.MarketData.get_historical_data/4","doc":"iex> get_historical_data(\"265598\", \"2w\", \"1hour\")\n    {:ok, [%HistoricalBar{timestamp: ~U[2024-02-05 14:00:00Z], open: 189.9, ...}, ...]}\n\n    iex> get_historical_data(\"265598\", \"1d\", \"5min\", outside_rth: true)\n    {:ok, [%HistoricalBar{...}, ...]}","ref":"IbkrApi.ClientPortal.MarketData.html#get_historical_data/4-examples"},{"type":"function","title":"IbkrApi.ClientPortal.MarketData.live_market_data_snapshots/2","doc":"Retrieves live market data snapshots for one or more contracts.\n\nFor derivative contracts, /iserver/secdef/search must be called first.","ref":"IbkrApi.ClientPortal.MarketData.html#live_market_data_snapshots/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.MarketData.live_market_data_snapshots/2","doc":"- `conids`: Contract identifier(s) - can be a single string or comma-separated string\n- `opts`: Optional parameters\n  - `:fields` - List of specific field codes to request (defaults to all fields)","ref":"IbkrApi.ClientPortal.MarketData.html#live_market_data_snapshots/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.MarketData.live_market_data_snapshots/2","doc":"iex> live_market_data_snapshots(\"265598\")\n    {:ok, [%MarketDataSnapshot{symbol: \"AAPL\", last_price: 150.25, ...}]}\n\n    iex> live_market_data_snapshots(\"265598,8314\", fields: [\"31\", \"55\"])\n    {:ok, [%MarketDataSnapshot{last_price: 150.25, symbol: \"AAPL\"}, ...]}","ref":"IbkrApi.ClientPortal.MarketData.html#live_market_data_snapshots/2-examples"},{"type":"module","title":"IbkrApi.ClientPortal.MarketData.HistoricalBar","doc":"Historical market data bar structure.","ref":"IbkrApi.ClientPortal.MarketData.HistoricalBar.html"},{"type":"function","title":"IbkrApi.ClientPortal.MarketData.HistoricalBar.from_ibkr/1","doc":"Converts IBKR API response data to HistoricalBar struct.","ref":"IbkrApi.ClientPortal.MarketData.HistoricalBar.html#from_ibkr/1"},{"type":"type","title":"IbkrApi.ClientPortal.MarketData.HistoricalBar.t/0","doc":"","ref":"IbkrApi.ClientPortal.MarketData.HistoricalBar.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.MarketData.MarketDataSnapshot","doc":"Market data snapshot response structure with descriptive field names.\nAll numeric field codes are mapped to their descriptive equivalents.","ref":"IbkrApi.ClientPortal.MarketData.MarketDataSnapshot.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.CancelOrderResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.CancelOrderResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.LiveOrder","doc":"","ref":"IbkrApi.ClientPortal.Order.LiveOrder.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.ModifyOrderRequest","doc":"Struct representing a request to modify an existing order.","ref":"IbkrApi.ClientPortal.Order.ModifyOrderRequest.html"},{"type":"type","title":"IbkrApi.ClientPortal.Order.ModifyOrderRequest.t/0","doc":"Type representing a modify order request struct.","ref":"IbkrApi.ClientPortal.Order.ModifyOrderRequest.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Order.ModifyOrderResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.ModifyOrderResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderPlacementResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderPlacementResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderPreviewRequest","doc":"Struct representing a request to preview an order before placement.","ref":"IbkrApi.ClientPortal.Order.OrderPreviewRequest.html"},{"type":"type","title":"IbkrApi.ClientPortal.Order.OrderPreviewRequest.t/0","doc":"Type representing an order preview request struct.","ref":"IbkrApi.ClientPortal.Order.OrderPreviewRequest.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderPreviewResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderPreviewResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderReplyResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderReplyResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderRequest","doc":"Struct representing a request to place a new order.","ref":"IbkrApi.ClientPortal.Order.OrderRequest.html"},{"type":"type","title":"IbkrApi.ClientPortal.Order.OrderRequest.t/0","doc":"Type representing an order request struct.","ref":"IbkrApi.ClientPortal.Order.OrderRequest.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderStatusResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderStatusResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio","doc":"Portfolio and Account management functions for IBKR Client Portal API.\nHandles account information, positions, allocations, summaries, and ledgers.","ref":"IbkrApi.ClientPortal.Portfolio.html"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_allocation/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_allocation/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_info/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_info/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_ledger/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_ledger/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_summary/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_summary/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.all_accounts_allocation/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#all_accounts_allocation/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.get_pnl/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#get_pnl/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.invalidate_positions_cache/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#invalidate_positions_cache/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_accounts/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_accounts/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_brokerage_accounts/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_brokerage_accounts/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_large_sub_accounts/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_large_sub_accounts/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_sub_accounts/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_sub_accounts/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.portfolio_positions/2","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#portfolio_positions/2"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.position_by_conid/2","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#position_by_conid/2"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.switch_account/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#switch_account/1"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.Account","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.Account.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.AccountAllocation","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.AccountAllocation.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.AccountLedger","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.AccountLedger.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.AccountSummary","doc":"AccountSummary struct containing all account summary fields.\nEach field is a SummaryField struct with timestamp, value, currency, severity, amount, and is_null information.","ref":"IbkrApi.ClientPortal.Portfolio.AccountSummary.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.BrokerageAccountsResponse","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.BrokerageAccountsResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.LargeSubAccounts","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.LargeSubAccounts.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.LedgerCurrency","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.LedgerCurrency.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.PnLAccountData","doc":"Represents PnL data for a specific account.\nContains daily and unrealized PnL information.","ref":"IbkrApi.ClientPortal.Portfolio.PnLAccountData.html"},{"type":"type","title":"IbkrApi.ClientPortal.Portfolio.PnLAccountData.t/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.PnLAccountData.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.PnLResponse","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.PnLResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.PortfolioPosition","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.PortfolioPosition.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SubAccount","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.SubAccount.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SubAccountsMetadata","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.SubAccountsMetadata.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SummaryField","doc":"Represents a single field in an account summary response.\nEach field contains metadata about the value including timestamp, currency, and severity.","ref":"IbkrApi.ClientPortal.Portfolio.SummaryField.html"},{"type":"type","title":"IbkrApi.ClientPortal.Portfolio.SummaryField.t/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.SummaryField.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SwitchAccountResponse","doc":"Response from switching accounts.\nCan contain different fields depending on the response:\n- success: String message when account is already set or successfully switched\n- set: Boolean indicating if account was set (in some responses)\n- acctId: Account ID that was switched to (in some responses)","ref":"IbkrApi.ClientPortal.Portfolio.SwitchAccountResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth","doc":"","ref":"IbkrApi.ClientPortal.Auth.html"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.check_auth_status/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#check_auth_status/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.end_session/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#end_session/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.ping_server/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#ping_server/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.reauthenticate/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#reauthenticate/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.validate_sso/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#validate_sso/0"},{"type":"module","title":"IbkrApi.ClientPortal.Contract","doc":"Contract-related functionality for the IBKR Client Portal API.\n\nThis module provides functions to retrieve contract information, trading schedules,\nsecurity definitions, and currency exchange rates.","ref":"IbkrApi.ClientPortal.Contract.html"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.contract_details/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#contract_details/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_available_currency_pairs/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_available_currency_pairs/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_contract_ids/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_ids/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_contract_info/2","doc":"Get detailed contract information using the secdef/info endpoint.\n\nReturns a list of contract information objects matching the criteria.","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_info/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.get_contract_info/2","doc":"- `conid` - Contract identifier (required)\n- `opts` - Optional parameters:\n  - `:sec_type` - Security type\n  - `:month` - Expiration month for derivatives\n  - `:exchange` - Specific exchange\n  - `:strike` - Strike price for options\n  - `:right` - \"C\" for Call, \"P\" for Put options\n  - `:issuer_id` - Issuer ID for bonds\n  - `:filters` - Comma-separated list of additional filters for bonds","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_info/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.get_contract_info/2","doc":"iex> IbkrApi.ClientPortal.Contract.get_contract_info(\"8314\")\n    {:ok, [%SecdefInfo{conid: 8314, symbol: \"IBM\", sec_type: \"STK\", ...}]}\n\n    iex> IbkrApi.ClientPortal.Contract.get_contract_info(\"265598\", sec_type: \"OPT\", strike: 250)\n    {:ok, [%SecdefInfo{conid: 795753109, symbol: \"NVDA\", right: \"C\", ...}, ...]}","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_info/2-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_currency_exchange_rate/2","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_currency_exchange_rate/2"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_nyse_trading_schedule/2","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_nyse_trading_schedule/2"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_stock_security_definition/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_stock_security_definition/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_strikes/2","doc":"Convenience function to get strikes for a symbol by first searching for the contract.\n\nThis function searches for the symbol, finds the first matching contract with options,\nthen retrieves the strikes for the current month.","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.get_strikes/2","doc":"- `symbol`: The ticker symbol to search for\n- `opts`: Optional parameters:\n  - `:month`: Date struct for expiration month (defaults to current month)\n  - `:sec_type`: Security type for search (defaults to \"STK\")","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.get_strikes/2","doc":"iex> get_strikes(\"AAPL\")\n    {:ok, %StrikesResponse{call: [150, 155, 160], put: [150, 155, 160]}}","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/2-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_strikes/4","doc":"Get option strikes for a given contract.","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/4"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.get_strikes/4","doc":"- `contract_id`: Contract identifier of the underlying or derivative\n- `sec_type`: Security type (e.g., \"OPT\" for options)\n- `month`: Elixir Date struct representing the expiration month\n- `opts`: Optional parameters including exchange (defaults to \"SMART\")","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/4-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.get_strikes/4","doc":"iex> date = ~D[2024-01-15]\n    iex> get_strikes(\"265598\", \"OPT\", date)\n    {:ok, %StrikesResponse{call: [70, 75, 80], put: [70, 75, 80]}}","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/4-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_trading_schedule/3","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_trading_schedule/3"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.search_contracts/2","doc":"Search for contracts based on symbol and other criteria.","ref":"IbkrApi.ClientPortal.Contract.html#search_contracts/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.search_contracts/2","doc":"- `symbol`: The ticker symbol, bond issuer type, or company name\n- `opts`: Optional parameters:\n  - `:sec_type`: Security type (\"STK\", \"IND\", \"BOND\") - defaults to \"STK\"\n  - `:name`: Boolean indicating if symbol is part of company name\n  - `:more`: Boolean for additional results\n  - `:fund`: Boolean for fund search\n  - `:fund_family_conid_ex`: String for fund family\n  - `:pattern`: Boolean for pattern search\n  - `:referrer`: String referrer","ref":"IbkrApi.ClientPortal.Contract.html#search_contracts/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.search_contracts/2","doc":"iex> search_contracts(\"AAPL\")\n    {:ok, [%SearchContract{symbol: \"AAPL\", conid: \"265598\", ...}]}","ref":"IbkrApi.ClientPortal.Contract.html#search_contracts/2-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.secdef_by_conid/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#secdef_by_conid/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.security_futures_by_symbol/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#security_futures_by_symbol/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.security_stocks_by_symbol/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#security_stocks_by_symbol/1"},{"type":"module","title":"IbkrApi.ClientPortal.Order","doc":"`IbkrApi.ClientPortal.Order` module for managing order placement and monitoring.","ref":"IbkrApi.ClientPortal.Order.html"},{"type":"function","title":"IbkrApi.ClientPortal.Order.cancel_order/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#cancel_order/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.get_live_orders/0","doc":"","ref":"IbkrApi.ClientPortal.Order.html#get_live_orders/0"},{"type":"function","title":"IbkrApi.ClientPortal.Order.get_order_status/1","doc":"","ref":"IbkrApi.ClientPortal.Order.html#get_order_status/1"},{"type":"function","title":"IbkrApi.ClientPortal.Order.modify_order/3","doc":"","ref":"IbkrApi.ClientPortal.Order.html#modify_order/3"},{"type":"function","title":"IbkrApi.ClientPortal.Order.place_orders/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#place_orders/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.place_orders_for_fa/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#place_orders_for_fa/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.preview_order/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#preview_order/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.reply_to_order_query/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#reply_to_order_query/2"},{"type":"module","title":"IbkrApi.ClientPortal.Trade","doc":"","ref":"IbkrApi.ClientPortal.Trade.html"},{"type":"function","title":"IbkrApi.ClientPortal.Trade.list_trades/0","doc":"","ref":"IbkrApi.ClientPortal.Trade.html#list_trades/0"},{"type":"module","title":"IbkrApi","doc":"# IbkrApi\n\nA comprehensive Elixir client for Interactive Brokers' Client Portal API. This library provides a clean, idiomatic Elixir interface to interact with Interactive Brokers' trading platform.","ref":"IbkrApi.html"},{"type":"module","title":"Features - IbkrApi","doc":"- Complete API coverage for Interactive Brokers' Client Portal API\n- Authentication and session management\n- Account information and portfolio management\n- Order placement and management\n- Market data and contract information\n- Trading operations\n- Profile management\n\nSee the [README](https://github.com/MikaAK/ibkr_api) for more information.","ref":"IbkrApi.html#module-features"},{"type":"module","title":"IbkrApi.Config","doc":"","ref":"IbkrApi.Config.html"},{"type":"function","title":"IbkrApi.Config.base_url/0","doc":"","ref":"IbkrApi.Config.html#base_url/0"},{"type":"function","title":"IbkrApi.Config.host/0","doc":"","ref":"IbkrApi.Config.html#host/0"},{"type":"function","title":"IbkrApi.Config.port/0","doc":"","ref":"IbkrApi.Config.html#port/0"},{"type":"module","title":"IbkrApi.HTTP","doc":"","ref":"IbkrApi.HTTP.html"},{"type":"function","title":"IbkrApi.HTTP.child_spec/1","doc":"","ref":"IbkrApi.HTTP.html#child_spec/1"},{"type":"function","title":"IbkrApi.HTTP.delete/3","doc":"","ref":"IbkrApi.HTTP.html#delete/3"},{"type":"function","title":"IbkrApi.HTTP.get/3","doc":"","ref":"IbkrApi.HTTP.html#get/3"},{"type":"function","title":"IbkrApi.HTTP.post/4","doc":"","ref":"IbkrApi.HTTP.html#post/4"},{"type":"extras","title":"IbkrApi","doc":"# IbkrApi\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ibkr_api.svg)](https://hex.pm/packages/ibkr_api)\n[![Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/ibkr_api)\n[![License](https://img.shields.io/badge/license-MIT-blue.svg)](https://opensource.org/licenses/MIT)\n\nA comprehensive Elixir client for Interactive Brokers' Client Portal API. This library provides a clean, idiomatic Elixir interface to interact with Interactive Brokers' trading platform.","ref":"readme.html"},{"type":"extras","title":"Features - IbkrApi","doc":"- Complete API coverage for Interactive Brokers' Client Portal API\n- Authentication and session management\n- Account information and portfolio management\n- Order placement and management\n- Market data and contract information\n- Trading operations\n- Profile management","ref":"readme.html#features"},{"type":"extras","title":"Installation - IbkrApi","doc":"Add `ibkr_api` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ibkr_api, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Quick Start - IbkrApi","doc":"```elixir\n# Authenticate with the IBKR Client Portal API\n{:ok, auth_response} = IbkrApi.ClientPortal.Auth.ping_server()\n\n# List your accounts\n{:ok, accounts} = IbkrApi.ClientPortal.Account.list_accounts()\n\n# Get account summary\naccount_id = hd(accounts).account_id\n{:ok, summary} = IbkrApi.ClientPortal.Account.account_summary(account_id)\n```","ref":"readme.html#quick-start"},{"type":"extras","title":"Documentation - IbkrApi","doc":"- **Tutorials**: Step-by-step guides to get you started\n  - [Getting Started](https://hexdocs.pm/ibkr_api/getting_started.html)\n  - [Authentication](https://hexdocs.pm/ibkr_api/authentication.html)\n\n- **How-To Guides**: Practical guides for specific tasks\n  - [Account Management](https://hexdocs.pm/ibkr_api/account_management.html)\n  - [Trading](https://hexdocs.pm/ibkr_api/trading.html)\n\n- **Reference**: Technical information and API details\n  - [API Reference](https://hexdocs.pm/ibkr_api/api_reference.html)\n\n- **Explanation**: Background information and concepts\n  - [Architecture](https://hexdocs.pm/ibkr_api/architecture.html)","ref":"readme.html#documentation"},{"type":"extras","title":"Prerequisites - IbkrApi","doc":"To use this library, you need:\n\n1. **Interactive Brokers account** - Active IBKR brokerage account\n2. **Java Runtime Environment** - Java 8 update 192 or later for the Client Portal Gateway\n3. **Client Portal Gateway** - Download and run locally:\n   - [Standard Release](https://download2.interactivebrokers.com/portal/clientportal.gw.zip)\n   - [Beta Release](https://download2.interactivebrokers.com/portal/clientportal.beta.gw.zip)\n4. **Elixir 1.15 or later**","ref":"readme.html#prerequisites"},{"type":"extras","title":"Contributing - IbkrApi","doc":"Contributions are welcome! Please feel free to submit a Pull Request.","ref":"readme.html#contributing"},{"type":"extras","title":"License - IbkrApi","doc":"This project is licensed under the MIT License - see the LICENSE file for details.","ref":"readme.html#license"},{"type":"extras","title":"Getting Started with IbkrApi","doc":"# Getting Started with IbkrApi\n\nThis tutorial will guide you through the process of setting up and using the IbkrApi library to interact with Interactive Brokers' Client Portal API.","ref":"getting_started.html"},{"type":"extras","title":"Prerequisites - Getting Started with IbkrApi","doc":"Before you begin, make sure you have:\n\n1. An Interactive Brokers account\n2. The Client Portal Gateway running locally or on a server\n3. Elixir 1.15 or later","ref":"getting_started.html#prerequisites"},{"type":"extras","title":"Installation - Getting Started with IbkrApi","doc":"Add `ibkr_api` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ibkr_api, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThen run:\n\n```bash\nmix deps.get\n```","ref":"getting_started.html#installation"},{"type":"extras","title":"Configuration - Getting Started with IbkrApi","doc":"Configure the library in your application's configuration file (`config/config.exs`):\n\n```elixir\nconfig :ibkr_api,\n  base_url: \"http://localhost:5000/v1/api\",  # Default Client Portal Gateway URL\n  timeout: 30_000  # Request timeout in milliseconds\n```\n\nYou can override these settings in your environment-specific configuration files.","ref":"getting_started.html#configuration"},{"type":"extras","title":"Starting the Client Portal Gateway - Getting Started with IbkrApi","doc":"Before using the library, you need to start the Interactive Brokers Client Portal Gateway:","ref":"getting_started.html#starting-the-client-portal-gateway"},{"type":"extras","title":"Prerequisites - Getting Started with IbkrApi","doc":"1. **Java Runtime Environment (JRE)**: The gateway requires Java 8 update 192 or later. Check if Java is installed:\n   ```bash\n   java -version\n   ```\n   If not installed, download from the [official Java website](https://www.java.com/en/download/)","ref":"getting_started.html#prerequisites"},{"type":"extras","title":"Download and Setup - Getting Started with IbkrApi","doc":"2. **Download the Client Portal Gateway**:\n   - [Standard Release](https://download2.interactivebrokers.com/portal/clientportal.gw.zip) (recommended)\n   - [Beta Release](https://download2.interactivebrokers.com/portal/clientportal.beta.gw.zip) (if you experience issues with standard)\n\n3. **Extract and run the gateway**:\n   ```bash\n   # Extract the downloaded file\n   unzip clientportal.gw.zip\n   cd clientportal.gw\n   \n   # On Unix/Linux/macOS:\n   bin/run.sh root/conf.yaml\n   \n   # On Windows:\n   bin\\run.bat root\\conf.yaml\n   ```\n\n**Important Notes:**\n- The gateway must run on the same machine where you'll make API calls\n- Default port is 5000 (configurable in `root/conf.yaml`)\n- You must authenticate through the browser on the same machine","ref":"getting_started.html#download-and-setup"},{"type":"extras","title":"Basic Usage - Getting Started with IbkrApi","doc":"","ref":"getting_started.html#basic-usage"},{"type":"extras","title":"Establishing a Connection - Getting Started with IbkrApi","doc":"First, you need to authenticate with the IBKR Client Portal API:\n\n```elixir\n# Check if the server is running and authenticate\n{:ok, response} = IbkrApi.ClientPortal.Auth.ping_server()\n\n# If you need to reauthenticate\n{:ok, _} = IbkrApi.ClientPortal.Auth.reauthenticate()\n```","ref":"getting_started.html#establishing-a-connection"},{"type":"extras","title":"Listing Accounts - Getting Started with IbkrApi","doc":"Once authenticated, you can list your accounts:\n\n```elixir\n{:ok, accounts} = IbkrApi.ClientPortal.Account.list_accounts()\n\n# Print account IDs\naccounts |> Enum.each(fn account -> IO.puts(account.account_id) end)\n```","ref":"getting_started.html#listing-accounts"},{"type":"extras","title":"Getting Account Information - Getting Started with IbkrApi","doc":"You can retrieve detailed information about a specific account:\n\n```elixir\naccount_id = \"U1234567\"  # Replace with your actual account ID\n{:ok, summary} = IbkrApi.ClientPortal.Account.account_summary(account_id)\n\n# Print available funds\nIO.puts(\"Available funds: #{summary.available_funds}\")\n```","ref":"getting_started.html#getting-account-information"},{"type":"extras","title":"Next Steps - Getting Started with IbkrApi","doc":"Now that you've set up the library and made your first API calls, you can:\n\n1. Learn more about [Authentication](authentication.html) processes\n2. Explore [Account Management](../how-to/account_management.html) operations\n3. Start [Trading](../how-to/trading.html) with the API\n\nFor a complete reference of all available functions, check the [API Reference](../reference/api_reference.html).","ref":"getting_started.html#next-steps"},{"type":"extras","title":"Authentication with IbkrApi","doc":"# Authentication with IbkrApi\n\nThis tutorial explains how to authenticate with the Interactive Brokers Client Portal API using the IbkrApi library.","ref":"authentication.html"},{"type":"extras","title":"Understanding IBKR Authentication - Authentication with IbkrApi","doc":"The Interactive Brokers Client Portal API uses a session-based authentication system. Before making API calls, you need to:\n\n1. Start the Client Portal Gateway\n2. Authenticate through the gateway's web interface\n3. Maintain your authenticated session","ref":"authentication.html#understanding-ibkr-authentication"},{"type":"extras","title":"Initial Authentication - Authentication with IbkrApi","doc":"When you first start the Client Portal Gateway, you need to authenticate through its web interface:\n\n1. **Download and start the gateway**:\n   - Download: [Standard Release](https://download2.interactivebrokers.com/portal/clientportal.gw.zip) or [Beta Release](https://download2.interactivebrokers.com/portal/clientportal.beta.gw.zip)\n   - Ensure Java 8+ is installed: `java -version`\n   - Extract and run: `bin/run.sh root/conf.yaml` (Unix) or `bin\\run.bat root\\conf.yaml` (Windows)\n\n2. **Authenticate via browser**:\n   - Open a browser and navigate to `http://localhost:5000`\n   - Log in with your Interactive Brokers credentials\n   - **Important**: Authentication must be done on the same machine where the gateway is running\n\n3. After successful login, you can start using the IbkrApi library","ref":"authentication.html#initial-authentication"},{"type":"extras","title":"Session Management with IbkrApi - Authentication with IbkrApi","doc":"","ref":"authentication.html#session-management-with-ibkrapi"},{"type":"extras","title":"Checking Authentication Status - Authentication with IbkrApi","doc":"To check if your session is still valid:\n\n```elixir\n{:ok, status} = IbkrApi.ClientPortal.Auth.check_auth_status()\n\nif status.authenticated do\n  IO.puts(\"Session is active\")\nelse\n  IO.puts(\"Session needs to be re-authenticated\")\nend\n```","ref":"authentication.html#checking-authentication-status"},{"type":"extras","title":"Pinging the Server - Authentication with IbkrApi","doc":"The `ping_server/0` function is a convenient way to check both connectivity and authentication status:\n\n```elixir\ncase IbkrApi.ClientPortal.Auth.ping_server() do\n  {:ok, response} ->\n    if response.iserver.auth_status.authenticated do\n      IO.puts(\"Connected and authenticated\")\n    else\n      IO.puts(\"Connected but not authenticated\")\n    end\n  \n  {:error, reason} ->\n    IO.puts(\"Connection error: #{inspect(reason)}\")\nend\n```","ref":"authentication.html#pinging-the-server"},{"type":"extras","title":"Reauthentication - Authentication with IbkrApi","doc":"If your session expires, you can attempt to reauthenticate:\n\n```elixir\n{:ok, response} = IbkrApi.ClientPortal.Auth.reauthenticate()\n\ncase response.message do\n  \"Authenticated\" -> IO.puts(\"Successfully reauthenticated\")\n  _ -> IO.puts(\"Reauthentication failed, please log in through the web interface\")\nend\n```\n\nNote that reauthentication may not always work if your session has been expired for too long. In such cases, you'll need to log in again through the web interface.","ref":"authentication.html#reauthentication"},{"type":"extras","title":"Validating SSO - Authentication with IbkrApi","doc":"For applications using Single Sign-On (SSO):\n\n```elixir\n{:ok, sso_info} = IbkrApi.ClientPortal.Auth.validate_sso()\n\nIO.puts(\"User: #{sso_info.user_name}\")\nIO.puts(\"Expires: #{sso_info.expires}\")\n```","ref":"authentication.html#validating-sso"},{"type":"extras","title":"Ending Your Session - Authentication with IbkrApi","doc":"When you're done using the API, it's good practice to end your session:\n\n```elixir\n{:ok, _} = IbkrApi.ClientPortal.Auth.end_session()\n```","ref":"authentication.html#ending-your-session"},{"type":"extras","title":"Authentication Flow in Production - Authentication with IbkrApi","doc":"In a production environment, you might want to implement a more robust authentication flow:\n\n```elixir\ndefmodule MyApp.IbkrAuthManager do\n  def ensure_authenticated do\n    case IbkrApi.ClientPortal.Auth.check_auth_status() do\n      {:ok, %{authenticated: true}} ->\n        {:ok, :authenticated}\n        \n      {:ok, %{authenticated: false}} ->\n        # Try to reauthenticate\n        case IbkrApi.ClientPortal.Auth.reauthenticate() do\n          {:ok, %{message: \"Authenticated\"}} -> {:ok, :reauthenticated}\n          _ -> {:error, :authentication_required}\n        end\n        \n      {:error, reason} ->\n        {:error, reason}\n    end\n  end\nend\n```","ref":"authentication.html#authentication-flow-in-production"},{"type":"extras","title":"Session Timeout Considerations - Authentication with IbkrApi","doc":"Interactive Brokers sessions typically time out after a period of inactivity. To maintain an active session:\n\n1. Implement a periodic ping to the server (e.g., every 5 minutes)\n2. Handle reauthentication automatically when needed\n3. Have a fallback mechanism for when reauthentication fails","ref":"authentication.html#session-timeout-considerations"},{"type":"extras","title":"Next Steps - Authentication with IbkrApi","doc":"Now that you understand how to manage authentication with the IBKR API, you can:\n\n1. Learn about [Account Management](../how-to/account_management.html)\n2. Start [Trading](../how-to/trading.html) with the API\n3. Explore the [API Reference](../reference/api_reference.html) for more details","ref":"authentication.html#next-steps"},{"type":"extras","title":"Account Management","doc":"# Account Management\n\nThis guide covers common account management tasks using the IbkrApi library.","ref":"account_management.html"},{"type":"extras","title":"Listing Accounts - Account Management","doc":"To retrieve all accounts associated with your Interactive Brokers login:\n\n```elixir\n{:ok, accounts} = IbkrApi.ClientPortal.Account.list_accounts()\n\n# Process the accounts\naccounts |> Enum.each(fn account ->\n  IO.puts(\"Account ID: #{account.account_id}\")\n  IO.puts(\"Account Title: #{account.account_title}\")\n  IO.puts(\"Account Type: #{account.type}\")\n  IO.puts(\"---\")\nend)\n```","ref":"account_management.html#listing-accounts"},{"type":"extras","title":"Retrieving Account Details - Account Management","doc":"","ref":"account_management.html#retrieving-account-details"},{"type":"extras","title":"Account Summary - Account Management","doc":"To get a comprehensive summary of an account:\n\n```elixir\naccount_id = \"U1234567\"  # Replace with your actual account ID\n{:ok, summary} = IbkrApi.ClientPortal.Account.account_summary(account_id)\n\n# Access common summary information\nIO.puts(\"Available Funds: #{summary.available_funds}\")\nIO.puts(\"Buying Power: #{summary.buying_power}\")\nIO.puts(\"Equity with Loan Value: #{summary.equity_with_loan_value}\")\nIO.puts(\"Excess Liquidity: #{summary.excess_liquidity}\")\n```","ref":"account_management.html#account-summary"},{"type":"extras","title":"Account Ledger - Account Management","doc":"To retrieve the account ledger information:\n\n```elixir\n{:ok, ledger} = IbkrApi.ClientPortal.Account.account_ledger(account_id)\n\n# Access ledger information for the base currency\nbase_currency = ledger.BASE\nIO.puts(\"Cash Balance: #{base_currency.cashbalance}\")\nIO.puts(\"Net Liquidation Value: #{base_currency.netliquidationvalue}\")\nIO.puts(\"Realized P&L: #{base_currency.realizedpnl}\")\nIO.puts(\"Unrealized P&L: #{base_currency.unrealizedpnl}\")\n```","ref":"account_management.html#account-ledger"},{"type":"extras","title":"Working with Sub-Accounts - Account Management","doc":"If you have a master account with sub-accounts:","ref":"account_management.html#working-with-sub-accounts"},{"type":"extras","title":"Listing Sub-Accounts - Account Management","doc":"```elixir\n{:ok, sub_accounts} = IbkrApi.ClientPortal.Account.list_sub_accounts()\n\n# Process sub-accounts\nsub_accounts |> Enum.each(fn sub_account ->\n  IO.puts(\"Sub-Account ID: #{sub_account.account_id}\")\n  IO.puts(\"Sub-Account Title: #{sub_account.account_title}\")\n  IO.puts(\"---\")\nend)\n```","ref":"account_management.html#listing-sub-accounts"},{"type":"extras","title":"Listing Large Sub-Accounts with Pagination - Account Management","doc":"For accounts with many sub-accounts:\n\n```elixir\n# Get the first page\n{:ok, large_sub_accounts} = IbkrApi.ClientPortal.Account.list_large_sub_accounts(\"0\")\n\n# Display metadata\nIO.puts(\"Total Sub-Accounts: #{large_sub_accounts.metadata.total}\")\nIO.puts(\"Page Size: #{large_sub_accounts.metadata.page_size}\")\n\n# Process sub-accounts on this page\nlarge_sub_accounts.subaccounts |> Enum.each(fn sub_account ->\n  IO.puts(\"Sub-Account ID: #{sub_account.account_id}\")\nend)\n\n# Get the next page if needed\nif large_sub_accounts.metadata.total > large_sub_accounts.metadata.page_size do\n  {:ok, next_page} = IbkrApi.ClientPortal.Account.list_large_sub_accounts(\"1\")\n  # Process next page...\nend\n```","ref":"account_management.html#listing-large-sub-accounts-with-pagination"},{"type":"extras","title":"Switching Between Accounts - Account Management","doc":"If you need to switch the active account for subsequent API calls:\n\n```elixir\ntarget_account_id = \"U7654321\"  # Replace with the account ID you want to switch to\n{:ok, switch_response} = IbkrApi.ClientPortal.Account.switch_account(target_account_id)\n\nif switch_response.set do\n  IO.puts(\"Successfully switched to account #{switch_response.acctId}\")\nelse\n  IO.puts(\"Failed to switch account\")\nend\n```","ref":"account_management.html#switching-between-accounts"},{"type":"extras","title":"Retrieving Profit and Loss Information - Account Management","doc":"To get P&L information for your account:\n\n```elixir\n{:ok, pnl_response} = IbkrApi.ClientPortal.Account.get_pnl()\n\n# Process P&L data\naccount_ids = Map.keys(pnl_response.acctId)\naccount_ids |> Enum.each(fn account_id ->\n  account_pnl = pnl_response.acctId[account_id]\n  IO.puts(\"Account: #{account_id}\")\n  IO.puts(\"P&L data: #{inspect(account_pnl)}\")\n  IO.puts(\"---\")\nend)\n```","ref":"account_management.html#retrieving-profit-and-loss-information"},{"type":"extras","title":"Error Handling - Account Management","doc":"All API functions return `{:ok, result}` on success and `{:error, reason}` on failure. It's good practice to handle errors appropriately:\n\n```elixir\ncase IbkrApi.ClientPortal.Account.account_summary(account_id) do\n  {:ok, summary} ->\n    # Process the summary...\n    IO.puts(\"Available Funds: #{summary.available_funds}\")\n    \n  {:error, %ErrorMessage{code: code, message: message}} ->\n    IO.puts(\"Error #{code}: #{message}\")\n    \n    # Handle specific error codes\n    case code do\n      \"1015\" -> IO.puts(\"Account not found or not authorized\")\n      \"1021\" -> IO.puts(\"Session expired, please reauthenticate\")\n      _ -> IO.puts(\"Unknown error\")\n    end\nend\n```","ref":"account_management.html#error-handling"},{"type":"extras","title":"Best Practices - Account Management","doc":"1. **Cache account information** when appropriate to reduce API calls\n2. **Check authentication status** before making account-related calls\n3. **Handle pagination** properly when dealing with large datasets\n4. **Implement proper error handling** for all API calls\n5. **Respect API rate limits** to avoid being temporarily blocked","ref":"account_management.html#best-practices"},{"type":"extras","title":"Related Resources - Account Management","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Trading](trading.html)\n- [API Reference](../reference/api_reference.html)","ref":"account_management.html#related-resources"},{"type":"extras","title":"Trading with IbkrApi","doc":"# Trading with IbkrApi\n\nThis guide covers how to perform trading operations using the IbkrApi library, including placing orders, modifying orders, and retrieving order status.","ref":"trading.html"},{"type":"extras","title":"Finding Contracts - Trading with IbkrApi","doc":"Before placing an order, you need to find the contract you want to trade:\n\n```elixir\n# Search for a stock by symbol\nsymbol = \"AAPL\"\n{:ok, contracts} = IbkrApi.ClientPortal.Contract.search_by_symbol(symbol)\n\n# Process the search results\ncontracts |> Enum.each(fn contract ->\n  IO.puts(\"Contract: #{contract.symbol}\")\n  IO.puts(\"Description: #{contract.description}\")\n  IO.puts(\"Contract ID: #{contract.conid}\")\n  IO.puts(\"---\")\nend)\n\n# Get the contract ID for use in orders\ncontract_id = List.first(contracts).conid\n```","ref":"trading.html#finding-contracts"},{"type":"extras","title":"Placing Orders - Trading with IbkrApi","doc":"","ref":"trading.html#placing-orders"},{"type":"extras","title":"Market Order - Trading with IbkrApi","doc":"To place a simple market order:\n\n```elixir\n# Define the order parameters\norder_params = %{\n  acctId: \"U1234567\",  # Replace with your account ID\n  conid: 265598,       # Contract ID for the instrument\n  orderType: \"MKT\",    # Market order\n  side: \"BUY\",         # BUY or SELL\n  quantity: 100,       # Number of shares/contracts\n  tif: \"DAY\"           # Time in force\n}\n\n# Place the order\n{:ok, order_response} = IbkrApi.ClientPortal.Order.place_order(order_params)\n\n# Get the order ID for future reference\norder_id = order_response.order_id\nIO.puts(\"Order placed with ID: #{order_id}\")\n```","ref":"trading.html#market-order"},{"type":"extras","title":"Limit Order - Trading with IbkrApi","doc":"For a limit order with a specific price:\n\n```elixir\nlimit_order_params = %{\n  acctId: \"U1234567\",\n  conid: 265598,\n  orderType: \"LMT\",    # Limit order\n  side: \"BUY\",\n  quantity: 100,\n  price: 150.25,       # Limit price\n  tif: \"DAY\"\n}\n\n{:ok, order_response} = IbkrApi.ClientPortal.Order.place_order(limit_order_params)\n```","ref":"trading.html#limit-order"},{"type":"extras","title":"Stop Order - Trading with IbkrApi","doc":"For a stop order:\n\n```elixir\nstop_order_params = %{\n  acctId: \"U1234567\",\n  conid: 265598,\n  orderType: \"STP\",    # Stop order\n  side: \"SELL\",\n  quantity: 100,\n  auxPrice: 145.50,    # Stop price\n  tif: \"GTC\"           # Good Till Canceled\n}\n\n{:ok, order_response} = IbkrApi.ClientPortal.Order.place_order(stop_order_params)\n```","ref":"trading.html#stop-order"},{"type":"extras","title":"Checking Order Status - Trading with IbkrApi","doc":"To check the status of your orders:\n\n```elixir\n# Get all live orders\n{:ok, orders} = IbkrApi.ClientPortal.Order.get_live_orders()\n\n# Process the orders\norders |> Enum.each(fn order ->\n  IO.puts(\"Order ID: #{order.order_id}\")\n  IO.puts(\"Status: #{order.status}\")\n  IO.puts(\"Contract: #{order.symbol}\")\n  IO.puts(\"Side: #{order.side}\")\n  IO.puts(\"Quantity: #{order.quantity}\")\n  IO.puts(\"---\")\nend)\n```","ref":"trading.html#checking-order-status"},{"type":"extras","title":"Modifying Orders - Trading with IbkrApi","doc":"To modify an existing order:\n\n```elixir\n# Order ID from the original order placement\norder_id = \"1234567890\"\n\n# New parameters for the order\nmodified_params = %{\n  acctId: \"U1234567\",\n  conid: 265598,\n  orderType: \"LMT\",\n  side: \"BUY\",\n  quantity: 150,       # Updated quantity\n  price: 148.75,       # Updated price\n  tif: \"DAY\"\n}\n\n{:ok, modified_response} = IbkrApi.ClientPortal.Order.modify_order(order_id, modified_params)\n```","ref":"trading.html#modifying-orders"},{"type":"extras","title":"Canceling Orders - Trading with IbkrApi","doc":"To cancel an order:\n\n```elixir\norder_id = \"1234567890\"\n{:ok, cancel_response} = IbkrApi.ClientPortal.Order.cancel_order(order_id)\n\nif cancel_response.success do\n  IO.puts(\"Order successfully canceled\")\nelse\n  IO.puts(\"Failed to cancel order: #{cancel_response.error}\")\nend\n```","ref":"trading.html#canceling-orders"},{"type":"extras","title":"Retrieving Executions - Trading with IbkrApi","doc":"To get information about executed trades:\n\n```elixir\n# Get executions for a specific account\naccount_id = \"U1234567\"\n{:ok, executions} = IbkrApi.ClientPortal.Trade.get_executions(account_id)\n\n# Process the executions\nexecutions |> Enum.each(fn execution ->\n  IO.puts(\"Execution ID: #{execution.execution_id}\")\n  IO.puts(\"Symbol: #{execution.symbol}\")\n  IO.puts(\"Side: #{execution.side}\")\n  IO.puts(\"Quantity: #{execution.quantity}\")\n  IO.puts(\"Price: #{execution.price}\")\n  IO.puts(\"Time: #{execution.time}\")\n  IO.puts(\"---\")\nend)\n```","ref":"trading.html#retrieving-executions"},{"type":"extras","title":"Order Types and Parameters - Trading with IbkrApi","doc":"Interactive Brokers supports a wide range of order types. Here are some common ones:\n\n| Order Type | Description | Required Parameters |\n|------------|-------------|---------------------|\n| MKT | Market Order | conid, side, quantity |\n| LMT | Limit Order | conid, side, quantity, price |\n| STP | Stop Order | conid, side, quantity, auxPrice |\n| STOP_LIMIT | Stop Limit Order | conid, side, quantity, price, auxPrice |\n| TRAIL | Trailing Stop | conid, side, quantity, auxPrice (trail amount) |","ref":"trading.html#order-types-and-parameters"},{"type":"extras","title":"Time in Force Options - Trading with IbkrApi","doc":"| TIF | Description |\n|-----|-------------|\n| DAY | Valid for the day |\n| GTC | Good Till Canceled |\n| IOC | Immediate or Cancel |\n| FOK | Fill or Kill |","ref":"trading.html#time-in-force-options"},{"type":"extras","title":"Error Handling - Trading with IbkrApi","doc":"All trading operations should include proper error handling:\n\n```elixir\ncase IbkrApi.ClientPortal.Order.place_order(order_params) do\n  {:ok, response} ->\n    IO.puts(\"Order placed successfully: #{response.order_id}\")\n    \n  {:error, %ErrorMessage{code: code, message: message}} ->\n    IO.puts(\"Error placing order: #{message}\")\n    \n    # Handle specific error codes\n    case code do\n      \"10001\" -> IO.puts(\"Insufficient funds\")\n      \"10020\" -> IO.puts(\"Contract not found\")\n      _ -> IO.puts(\"Unknown error\")\n    end\nend\n```","ref":"trading.html#error-handling"},{"type":"extras","title":"Best Practices - Trading with IbkrApi","doc":"1. **Validate contract information** before placing orders\n2. **Start with small orders** when testing new strategies\n3. **Implement proper error handling** for all trading operations\n4. **Check order status** after placement to ensure it was accepted\n5. **Use paper trading accounts** for testing and development\n6. **Respect API rate limits** to avoid being temporarily blocked","ref":"trading.html#best-practices"},{"type":"extras","title":"Related Resources - Trading with IbkrApi","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Account Management](account_management.html)\n- [API Reference](../reference/api_reference.html)","ref":"trading.html#related-resources"},{"type":"extras","title":"API Reference","doc":"# API Reference\n\nThis reference guide provides detailed information about all modules and functions available in the IbkrApi library.","ref":"api_reference.html"},{"type":"extras","title":"Core Modules - API Reference","doc":"","ref":"api_reference.html#core-modules"},{"type":"extras","title":"IbkrApi - API Reference","doc":"`IbkrApi` module that serves as the entry point to the library.","ref":"api_reference.html#ibkrapi"},{"type":"extras","title":"IbkrApi.Config - API Reference","doc":"`IbkrApi.Config` module for configuration management.\n\n```elixir\n# Get the base URL for API requests\nbase_url = IbkrApi.Config.base_url()\n```","ref":"api_reference.html#ibkrapi-config"},{"type":"extras","title":"IbkrApi.HTTP - API Reference","doc":"`IbkrApi.HTTP` module for making requests to the Interactive Brokers Client Portal API.\n\n```elixir\n# Make a GET request\n{:ok, response} = IbkrApi.HTTP.get(\"https://localhost:5000/v1/api/endpoint\")\n\n# Make a POST request with a body\nbody = %{key: \"value\"}\n{:ok, response} = IbkrApi.HTTP.post(\"https://localhost:5000/v1/api/endpoint\", body)\n```","ref":"api_reference.html#ibkrapi-http"},{"type":"extras","title":"Client Portal Modules - API Reference","doc":"","ref":"api_reference.html#client-portal-modules"},{"type":"extras","title":"IbkrApi.ClientPortal.Auth - API Reference","doc":"`IbkrApi.ClientPortal.Auth` module for authentication and session management.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `ping_server/0` | Checks server connectivity and authentication status | None | `{:ok, %PingServerResponse{}}` or `{:error, reason}` |\n| `reauthenticate/0` | Attempts to reauthenticate an expired session | None | `{:ok, %ReauthenticateResponse{}}` or `{:error, reason}` |\n| `end_session/0` | Ends the current session | None | `{:ok, %EndSessionResponse{}}` or `{:error, reason}` |\n| `validate_sso/0` | Validates Single Sign-On status | None | `{:ok, %ValidateSSOResponse{}}` or `{:error, reason}` |\n| `check_auth_status/0` | Checks the current authentication status | None | `{:ok, %CheckAuthStatusResponse{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-auth"},{"type":"extras","title":"IbkrApi.ClientPortal.Account - API Reference","doc":"`IbkrApi.ClientPortal.Account` module for managing account information and operations.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `list_accounts/0` | Lists all portfolio accounts | None | `{:ok, [%Account{}]}` or `{:error, reason}` |\n| `list_sub_accounts/0` | Lists all sub-accounts | None | `{:ok, [%SubAccount{}]}` or `{:error, reason}` |\n| `list_large_sub_accounts/1` | Lists sub-accounts with pagination | `page` (String) | `{:ok, %LargeSubAccounts{}}` or `{:error, reason}` |\n| `account_info/1` | Gets account metadata | `account_id` (String) | `{:ok, %Account{}}` or `{:error, reason}` |\n| `account_summary/1` | Gets account summary | `account_id` (String) | `{:ok, %AccountSummary{}}` or `{:error, reason}` |\n| `account_ledger/1` | Gets account ledger | `account_id` (String) | `{:ok, %AccountLedger{}}` or `{:error, reason}` |\n| `list_brokerage_accounts/0` | Lists all brokerage accounts | None | `{:ok, %BrokerageAccountsResponse{}}` or `{:error, reason}` |\n| `switch_account/1` | Switches the active account | `acctId` (String) | `{:ok, %SwitchAccountResponse{}}` or `{:error, reason}` |\n| `get_pnl/0` | Gets profit and loss information | None | `{:ok, %PnLResponse{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-account"},{"type":"extras","title":"IbkrApi.ClientPortal.Contract - API Reference","doc":"`IbkrApi.ClientPortal.Contract` module for managing financial instruments and contracts.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `search_by_symbol/1` | Searches for contracts by symbol | `symbol` (String) | `{:ok, [%Contract{}]}` or `{:error, reason}` |\n| `get_contract_details/1` | Gets detailed information for a contract | `conid` (Integer) | `{:ok, %ContractDetails{}}` or `{:error, reason}` |\n| `get_contract_info/1` | Gets basic information for a contract | `conid` (Integer) | `{:ok, %ContractInfo{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-contract"},{"type":"extras","title":"IbkrApi.ClientPortal.Order - API Reference","doc":"`IbkrApi.ClientPortal.Order` module for managing order placement and monitoring.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `place_order/1` | Places a new order | `order_params` (Map) | `{:ok, %OrderResponse{}}` or `{:error, reason}` |\n| `modify_order/2` | Modifies an existing order | `order_id` (String), `order_params` (Map) | `{:ok, %OrderResponse{}}` or `{:error, reason}` |\n| `cancel_order/1` | Cancels an order | `order_id` (String) | `{:ok, %CancelResponse{}}` or `{:error, reason}` |\n| `get_live_orders/0` | Gets all live orders | None | `{:ok, [%Order{}]}` or `{:error, reason}` |\n| `get_order_status/1` | Gets status of a specific order | `order_id` (String) | `{:ok, %Order{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-order"},{"type":"extras","title":"IbkrApi.ClientPortal.Profile - API Reference","doc":"`IbkrApi.ClientPortal.Profile` module for managing user profile information.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `get_profile/0` | Gets user profile information | None | `{:ok, %Profile{}}` or `{:error, reason}` |\n| `update_profile/1` | Updates user profile | `profile_params` (Map) | `{:ok, %UpdateProfileResponse{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-profile"},{"type":"extras","title":"IbkrApi.ClientPortal.Trade - API Reference","doc":"`IbkrApi.ClientPortal.Trade` module for managing trade executions and history.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `get_executions/1` | Gets trade executions for an account | `account_id` (String) | `{:ok, [%Execution{}]}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-trade"},{"type":"extras","title":"Error Handling - API Reference","doc":"All API functions return `{:ok, result}` on success and `{:error, reason}` on failure. The error reason is typically an `ErrorMessage` struct with the following fields:\n\n```elixir\n%ErrorMessage{\n  code: \"1234\",       # Error code\n  message: \"Error message description\",\n  description: \"Detailed error description\"\n}\n```","ref":"api_reference.html#error-handling"},{"type":"extras","title":"Common Error Codes - API Reference","doc":"| Code | Description |\n|------|-------------|\n| \"1015\" | Account not found or not authorized |\n| \"1021\" | Session expired, please reauthenticate |\n| \"1022\" | Invalid contract ID |\n| \"1100\" | Invalid order parameters |\n| \"1101\" | Insufficient funds |\n| \"2000\" | Server error |","ref":"api_reference.html#common-error-codes"},{"type":"extras","title":"Related Resources - API Reference","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Account Management](../how-to/account_management.html)\n- [Trading](../how-to/trading.html)\n- [Architecture](../explanations/architecture.html)","ref":"api_reference.html#related-resources"},{"type":"extras","title":"Architecture of IbkrApi","doc":"# Architecture of IbkrApi\n\nThis document explains the architecture and design principles of the IbkrApi library, providing context for developers who want to understand how the library works internally.","ref":"architecture.html"},{"type":"extras","title":"Overview - Architecture of IbkrApi","doc":"IbkrApi is designed as a clean, idiomatic Elixir wrapper around Interactive Brokers' Client Portal API. The library follows these key design principles:\n\n1. **Simplicity**: Providing a straightforward interface to the IBKR API\n2. **Consistency**: Maintaining a consistent API design across all modules\n3. **Error Handling**: Comprehensive error handling with meaningful messages\n4. **Type Safety**: Using structs and typespecs for better code quality","ref":"architecture.html#overview"},{"type":"extras","title":"System Architecture - Architecture of IbkrApi","doc":"The library is organized into several layers:\n\n```\n┌─────────────────────────────────────────────────┐\n│                  Client Code                    │\n└───────────────────────┬─────────────────────────┘\n                        │\n┌───────────────────────▼─────────────────────────┐\n│               IbkrApi.ClientPortal              │\n│  ┌─────────┐  ┌─────────┐  ┌─────────┐  ┌─────┐ │\n│  │  Auth   │  │ Account │  │ Order   │  │ ... │ │\n│  └─────────┘  └─────────┘  └─────────┘  └─────┘ │\n└───────────────────────┬─────────────────────────┘\n                        │\n┌───────────────────────▼─────────────────────────┐\n│                  IbkrApi.HTTP                   │\n└───────────────────────┬─────────────────────────┘\n                        │\n┌───────────────────────▼─────────────────────────┐\n│                     Finch                       │\n└───────────────────────┬─────────────────────────┘\n                        │\n┌───────────────────────▼─────────────────────────┐\n│            IBKR Client Portal Gateway           │\n└─────────────────────────────────────────────────┘\n```","ref":"architecture.html#system-architecture"},{"type":"extras","title":"Core Components - Architecture of IbkrApi","doc":"1. **IbkrApi**: The main module that serves as the entry point to the library\n2. **IbkrApi.Application**: Manages the application lifecycle and dependencies\n3. **IbkrApi.Config**: Handles configuration for the library\n4. **IbkrApi.HTTP**: Low-level HTTP client for making requests to the API","ref":"architecture.html#core-components"},{"type":"extras","title":"Domain-Specific Modules - Architecture of IbkrApi","doc":"The `IbkrApi.ClientPortal` namespace contains domain-specific modules that correspond to different areas of the IBKR API:\n\n1. **IbkrApi.ClientPortal.Auth**: Authentication and session management\n2. **IbkrApi.ClientPortal.Account**: Account information and operations\n3. **IbkrApi.ClientPortal.Contract**: Financial instruments and contracts\n4. **IbkrApi.ClientPortal.Order**: Order placement and monitoring\n5. **IbkrApi.ClientPortal.Profile**: User profile information\n6. **IbkrApi.ClientPortal.Trade**: Trade executions and history","ref":"architecture.html#domain-specific-modules"},{"type":"extras","title":"Data Flow - Architecture of IbkrApi","doc":"A typical request through the library follows this flow:\n\n1. Client code calls a function in one of the domain-specific modules\n2. The domain module constructs the appropriate request parameters\n3. The request is passed to `IbkrApi.HTTP` which handles the HTTP communication\n4. `IbkrApi.HTTP` uses Finch to make the actual HTTP request to the IBKR Gateway\n5. The response is received and parsed (typically from JSON to Elixir structs)\n6. The domain module returns the structured response to the client code","ref":"architecture.html#data-flow"},{"type":"extras","title":"Error Handling - Architecture of IbkrApi","doc":"The library uses the `ErrorMessage` module for consistent error handling:\n\n```elixir\ndefmodule ErrorMessage do\n  @type t :: %__MODULE__{\n    code: String.t() | nil,\n    message: String.t() | nil,\n    description: String.t() | nil\n  }\n  \n  @type t_res :: {:ok, any()} | {:error, t()}\n  \n  defstruct [:code, :message, :description]\nend\n```\n\nAll API functions return either `{:ok, result}` on success or `{:error, %ErrorMessage{}}` on failure, allowing for consistent error handling throughout the application.","ref":"architecture.html#error-handling"},{"type":"extras","title":"Data Structures - Architecture of IbkrApi","doc":"The library uses Elixir structs to represent API responses. Each domain module defines its own set of structs that match the structure of the API responses. For example:\n\n```elixir\ndefmodule IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse do\n  defstruct authenticated: nil, competing: nil, connected: nil,\n            fail: nil, hardware_info: nil, mac: nil, message: nil,\n            server_info: %IbkrApi.ClientPortal.Auth.ServerInfo{}\nend\n```\n\nThis approach provides type safety and makes it clear what data is available from each API call.","ref":"architecture.html#data-structures"},{"type":"extras","title":"Configuration - Architecture of IbkrApi","doc":"The library is configured through the standard Elixir configuration system:\n\n```elixir\nconfig :ibkr_api,\n  base_url: \"http://localhost:5000/v1/api\",\n  timeout: 30_000\n```\n\nThe `IbkrApi.Config` module provides functions to access this configuration:\n\n```elixir\ndefmodule IbkrApi.Config do\n  def base_url, do: Application.get_env(:ibkr_api, :base_url, \"http://localhost:5000/v1/api\")\n  def timeout, do: Application.get_env(:ibkr_api, :timeout, 30_000)\nend\n```","ref":"architecture.html#configuration"},{"type":"extras","title":"HTTP Client - Architecture of IbkrApi","doc":"The `IbkrApi.HTTP` module handles all HTTP communication with the IBKR API. It uses Finch for making HTTP requests and Jason for JSON encoding/decoding:\n\n```elixir\ndefmodule IbkrApi.HTTP do\n  @spec get(String.t()) :: ErrorMessage.t_res()\n  def get(url) do\n    # Implementation...\n  end\n\n  @spec post(String.t(), map()) :: ErrorMessage.t_res()\n  def post(url, body) do\n    # Implementation...\n  end\nend\n```","ref":"architecture.html#http-client"},{"type":"extras","title":"Design Decisions - Architecture of IbkrApi","doc":"","ref":"architecture.html#design-decisions"},{"type":"extras","title":"Why Finch? - Architecture of IbkrApi","doc":"Finch was chosen as the HTTP client because:\n- It's a modern, fast HTTP client for Elixir\n- It provides connection pooling for better performance\n- It's well-maintained and widely used in the Elixir community","ref":"architecture.html#why-finch"},{"type":"extras","title":"Why Structs for API Responses? - Architecture of IbkrApi","doc":"Structs were chosen to represent API responses because:\n- They provide a clear structure for the data\n- They enable type checking with dialyzer\n- They make it clear what data is available from each API call\n- They allow for pattern matching in client code","ref":"architecture.html#why-structs-for-api-responses"},{"type":"extras","title":"Why the ClientPortal Namespace? - Architecture of IbkrApi","doc":"The `IbkrApi.ClientPortal` namespace was created to:\n- Separate the Client Portal API from potential future APIs\n- Group related functionality together\n- Allow for easy discovery of available modules","ref":"architecture.html#why-the-clientportal-namespace"},{"type":"extras","title":"Testing Strategy - Architecture of IbkrApi","doc":"The library is designed to be testable at multiple levels:\n\n1. **Unit Tests**: Test individual functions in isolation\n2. **Integration Tests**: Test interaction between modules\n3. **API Tests**: Test actual communication with the IBKR API (requires a running gateway)\n\nMock modules can be used to simulate API responses for testing without a live connection to the IBKR gateway.","ref":"architecture.html#testing-strategy"},{"type":"extras","title":"Future Considerations - Architecture of IbkrApi","doc":"Potential future enhancements to the architecture include:\n\n1. **Streaming Support**: Adding support for WebSocket streaming for real-time data\n2. **Rate Limiting**: Implementing intelligent rate limiting to avoid API throttling\n3. **Caching**: Adding a caching layer for frequently accessed data\n4. **Retry Logic**: Implementing automatic retries for transient failures\n5. **Async Operations**: Supporting asynchronous operations for long-running requests","ref":"architecture.html#future-considerations"},{"type":"extras","title":"Related Resources - Architecture of IbkrApi","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Account Management](../how-to/account_management.html)\n- [Trading](../how-to/trading.html)\n- [API Reference](../reference/api_reference.html)","ref":"architecture.html#related-resources"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}